#pragma ident "$Id: //depot/sgl/gpstk/dev/apps/reszilla/readers.hpp#3 $"
//
// Utilitiy functions for reading in various types of data
//

#include <iostream>
#include <iomanip>
#include <string>
#include <map>

// gpstk crud
#include "DayTime.hpp"

#include "RinexObsStream.hpp"
#include "RinexObsData.hpp"

#include "RinexNavStream.hpp"
#include "RinexNavData.hpp"
#include "RinexMetStream.hpp"
#include "RinexMetData.hpp"

#include "FICStream.hpp"
#include "FICData.hpp"

#include "SMODFStream.hpp"
#include "SMODFData.hpp"

#include "MSCData.hpp"
#include "MSCStream.hpp"

#include "CommandOption.hpp"
#include "CommandOptionParser.hpp"

#include "EphemerisStore.hpp"

extern int verbosity;

// a store of epochs for a single receiver/antenna
typedef std::map<gpstk::DayTime, gpstk::RinexObsData> RODEpochMap;

void read_obs_data(std::string& fn,
                   unsigned long msid,
                   RODEpochMap& rem,
                   gpstk::RinexObsHeader& roh);

void read_rinex_data(std::string& fn, 
                     RODEpochMap& rem, 
                     gpstk::RinexObsHeader& roh);

void read_aoa_data(std::string& fn,
                   RODEpochMap& rem, 
                   gpstk::RinexObsHeader& roh);

void read_msc_data(std::string& fn, 
                   unsigned long msid,
                   gpstk::RinexObsHeader& roh);

void read_smo_data(std::string& fn,
                   unsigned long msid,
                   RODEpochMap& rem, 
                   gpstk::RinexObsHeader& roh);

void read_pec_data(std::string& fn,
                   unsigned long msid,
                   RODEpochMap& rem);

gpstk::EphemerisStore& read_eph_data(gpstk::CommandOption& files);

gpstk::WxObsData& read_met_data(gpstk::CommandOption& files);


